import { Pool, PoolConfig } from 'pg';
import SqlQuery from '../Queries/SqlQuery';
import DatabaseInterface from './DatabaseInterface';
export default class PgSqlDatabase implements DatabaseInterface {
    readonly pool: Pool;
    constructor(pool: PoolConfig | Pool);
    disconnect(): Promise<void>;
    indexToPlaceholder(i: number): string;
    private queryPoolOrClient;
    query(query: SqlQuery): Promise<any[]>;
    sequence<T>(sequence: (query: (query: SqlQuery) => Promise<any[]>) => Promise<T>): Promise<T>;
    migrate(migrations: {
        [key: string]: SqlQuery;
    }): Promise<void>;
}
