"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var pg_1 = require("pg");
var pg_format_1 = require("pg-format");
var SqlQuery_1 = require("../Queries/SqlQuery");
var sql = SqlQuery_1.default.createFromTemplateString;
var PgSqlDatabase = /** @class */ (function () {
    function PgSqlDatabase(pool) {
        var _this = this;
        this.queryPoolOrClient = function (client, query) { return __awaiter(_this, void 0, void 0, function () {
            var compiledQuery, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        compiledQuery = query.compile(this.indexToPlaceholder, pg_format_1.ident);
                        return [4 /*yield*/, client.query(compiledQuery.sql, compiledQuery.params)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.rows];
                }
            });
        }); };
        if (pool instanceof pg_1.Pool) {
            this.pool = pool;
        }
        else {
            this.pool = new pg_1.Pool(pool);
        }
    }
    PgSqlDatabase.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.pool.end()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PgSqlDatabase.prototype.indexToPlaceholder = function (i) {
        return '$' + (i + 1);
    };
    PgSqlDatabase.prototype.query = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.queryPoolOrClient(this.pool, query)];
            });
        });
    };
    PgSqlDatabase.prototype.sequence = function (sequence) {
        return __awaiter(this, void 0, void 0, function () {
            var client, result, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.pool.connect()];
                    case 1:
                        client = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, sequence(function (query) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, this.queryPoolOrClient(client, query)];
                                });
                            }); })];
                    case 3:
                        result = _a.sent();
                        client.release();
                        return [2 /*return*/, result];
                    case 4:
                        error_1 = _a.sent();
                        client.release();
                        throw error_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    PgSqlDatabase.prototype.migrate = function (migrations) {
        return __awaiter(this, void 0, void 0, function () {
            var migrationsDone, _loop_1, this_1, _a, _b, _c, migrationName, migrationQuery, e_1_1;
            var e_1, _d;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0: return [4 /*yield*/, this.query(sql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\tCREATE TABLE IF NOT EXISTS \"Migrations\" (\n\t\t\t\t\"name\" TEXT PRIMARY KEY NOT NULL\n\t\t\t);\n\t\t"], ["\n\t\t\tCREATE TABLE IF NOT EXISTS \"Migrations\" (\n\t\t\t\t\"name\" TEXT PRIMARY KEY NOT NULL\n\t\t\t);\n\t\t"]))))];
                    case 1:
                        _e.sent();
                        return [4 /*yield*/, this.query(sql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["SELECT * FROM \"Migrations\";"], ["SELECT * FROM \"Migrations\";"]))))];
                    case 2:
                        migrationsDone = _e.sent();
                        _loop_1 = function (migrationName, migrationQuery) {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (migrationsDone.some(function (migrationDone) { return migrationDone.name === migrationName; })) {
                                            return [2 /*return*/, "continue"];
                                        }
                                        return [4 /*yield*/, this_1.sequence(function (query) { return __awaiter(_this, void 0, void 0, function () {
                                                var error_2;
                                                return __generator(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, query(sql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["BEGIN;"], ["BEGIN;"]))))];
                                                        case 1:
                                                            _a.sent();
                                                            _a.label = 2;
                                                        case 2:
                                                            _a.trys.push([2, 5, , 7]);
                                                            return [4 /*yield*/, query(migrationQuery)];
                                                        case 3:
                                                            _a.sent();
                                                            return [4 /*yield*/, query(sql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["INSERT INTO \"Migrations\" VALUES (", ");"], ["INSERT INTO \"Migrations\" VALUES (", ");"])), migrationName))];
                                                        case 4:
                                                            _a.sent();
                                                            return [3 /*break*/, 7];
                                                        case 5:
                                                            error_2 = _a.sent();
                                                            return [4 /*yield*/, query(sql(templateObject_5 || (templateObject_5 = __makeTemplateObject(["ROLLBACK;"], ["ROLLBACK;"]))))];
                                                        case 6:
                                                            _a.sent();
                                                            throw error_2;
                                                        case 7: return [4 /*yield*/, query(sql(templateObject_6 || (templateObject_6 = __makeTemplateObject(["COMMIT;"], ["COMMIT;"]))))];
                                                        case 8:
                                                            _a.sent();
                                                            return [2 /*return*/];
                                                    }
                                                });
                                            }); })];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _e.label = 3;
                    case 3:
                        _e.trys.push([3, 8, 9, 10]);
                        _a = __values(Object.entries(migrations)), _b = _a.next();
                        _e.label = 4;
                    case 4:
                        if (!!_b.done) return [3 /*break*/, 7];
                        _c = __read(_b.value, 2), migrationName = _c[0], migrationQuery = _c[1];
                        return [5 /*yield**/, _loop_1(migrationName, migrationQuery)];
                    case 5:
                        _e.sent();
                        _e.label = 6;
                    case 6:
                        _b = _a.next();
                        return [3 /*break*/, 4];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    return PgSqlDatabase;
}());
exports.default = PgSqlDatabase;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
