import QueryIdentifier from './QueryIdentifier';
import QueryParam from './QueryParam';
import CompiledQuery from './CompiledQuery';
declare type QueryPart = string | QueryIdentifier | QueryParam | SqlQuery;
export default class SqlQuery {
    readonly parts: ReadonlyArray<QueryPart>;
    static createFromTemplateString(strings: TemplateStringsArray, ...params: ReadonlyArray<any>): SqlQuery;
    /**
     * The delimiter is an SqlQuery rather than a string
     * in order to avoid potential SQL injections.
     */
    static join(queries: SqlQuery[], delimiter?: SqlQuery): SqlQuery;
    constructor(parts: ReadonlyArray<QueryPart>);
    compile(indexToPlaceholder: (i: number) => string, formatIdentifier: (s: string) => string): CompiledQuery;
}
export {};
