"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var NotFoundError_1 = require("../Errors/NotFoundError");
var TooManyResultsError_1 = require("../Errors/TooManyResultsError");
var RelationshipNotFoundError_1 = require("../Errors/RelationshipNotFoundError");
var SqlQuery_1 = require("../Queries/SqlQuery");
var QueryIdentifier_1 = require("../Queries/QueryIdentifier");
var sql = SqlQuery_1.default.createFromTemplateString;
var CrudRepository = /** @class */ (function () {
    function CrudRepository(_a) {
        var database = _a.database, table = _a.table, model = _a.model, primaryKey = _a.primaryKey, _b = _a.scope, scope = _b === void 0 ? null : _b, _c = _a.relationships, relationships = _c === void 0 ? {} : _c;
        this.database = database;
        this.table = table;
        this.primaryKey = primaryKey;
        this.model = model;
        this.scope = scope;
        this.relationships = relationships;
    }
    CrudRepository.prototype.get = function (primaryKeyValue) {
        return __awaiter(this, void 0, void 0, function () {
            var filters, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filters = [
                            sql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " = ", ""], ["", " = ", ""])), new QueryIdentifier_1.default(this.primaryKey), primaryKeyValue),
                        ];
                        if (this.scope !== null) {
                            filters.push(sql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["(", ")"], ["(", ")"])), this.scope));
                        }
                        return [4 /*yield*/, this.database.query(sql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t\t\tSELECT *\n\t\t\tFROM ", "\n\t\t\tWHERE ", ";\n\t\t"], ["\n\t\t\tSELECT *\n\t\t\tFROM ", "\n\t\t\tWHERE ", ";\n\t\t"])), new QueryIdentifier_1.default(this.table), SqlQuery_1.default.join(filters, sql(templateObject_3 || (templateObject_3 = __makeTemplateObject([" AND "], [" AND "]))))))];
                    case 1:
                        results = _a.sent();
                        if (results.length === 0) {
                            throw new NotFoundError_1.default("Object not found in table " + this.table + " for " + this.primaryKey + " = " + primaryKeyValue);
                        }
                        if (results.length > 1) {
                            throw new TooManyResultsError_1.default("Multiple objects found in table " + this.table + " for " + this.primaryKey + " = " + primaryKeyValue);
                        }
                        return [2 /*return*/, this.createModelFromAttributes(results[0])];
                }
            });
        });
    };
    CrudRepository.prototype.search = function (where, orderBy) {
        if (where === void 0) { where = null; }
        if (orderBy === void 0) { orderBy = null; }
        return __awaiter(this, void 0, void 0, function () {
            var filters, whereClause, orderByClause, results;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filters = [];
                        if (this.scope !== null) {
                            filters.push(sql(templateObject_5 || (templateObject_5 = __makeTemplateObject(["(", ")"], ["(", ")"])), this.scope));
                        }
                        if (where !== null) {
                            filters.push(sql(templateObject_6 || (templateObject_6 = __makeTemplateObject(["(", ")"], ["(", ")"])), where));
                        }
                        whereClause = filters.length === 0
                            ? sql(templateObject_7 || (templateObject_7 = __makeTemplateObject([""], [""]))) : sql(templateObject_9 || (templateObject_9 = __makeTemplateObject(["WHERE ", ""], ["WHERE ", ""])), SqlQuery_1.default.join(filters, sql(templateObject_8 || (templateObject_8 = __makeTemplateObject([" AND "], [" AND "])))));
                        orderByClause = orderBy === null
                            ? sql(templateObject_10 || (templateObject_10 = __makeTemplateObject([""], [""]))) : sql(templateObject_11 || (templateObject_11 = __makeTemplateObject(["ORDER BY ", ""], ["ORDER BY ", ""])), orderBy);
                        return [4 /*yield*/, this.database.query(sql(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n\t\t\tSELECT *\n\t\t\tFROM ", "\n\t\t\t", "\n\t\t\t", "\n\t\t"], ["\n\t\t\tSELECT *\n\t\t\tFROM ", "\n\t\t\t", "\n\t\t\t", "\n\t\t"])), new QueryIdentifier_1.default(this.table), whereClause, orderByClause))];
                    case 1:
                        results = _a.sent();
                        return [2 /*return*/, Promise.all(results.map(function (result) { return _this.createModelFromAttributes(result); }))];
                }
            });
        });
    };
    CrudRepository.prototype.create = function (attributes) {
        return __awaiter(this, void 0, void 0, function () {
            var entries, fields, values, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        entries = Object.entries(attributes);
                        fields = entries.map(function (_a) {
                            var _b = __read(_a, 2), key = _b[0], _ = _b[1];
                            return sql(templateObject_13 || (templateObject_13 = __makeTemplateObject(["", ""], ["", ""])), new QueryIdentifier_1.default(key));
                        });
                        values = entries.map(function (_a) {
                            var _b = __read(_a, 2), _ = _b[0], val = _b[1];
                            return sql(templateObject_14 || (templateObject_14 = __makeTemplateObject(["", ""], ["", ""])), val);
                        });
                        return [4 /*yield*/, this.database.query(sql(templateObject_17 || (templateObject_17 = __makeTemplateObject(["\n\t\t\tINSERT INTO ", " (", ")\n\t\t\tVALUES (", ")\n\t\t\tRETURNING *;\n\t\t"], ["\n\t\t\tINSERT INTO ", " (", ")\n\t\t\tVALUES (", ")\n\t\t\tRETURNING *;\n\t\t"])), new QueryIdentifier_1.default(this.table), SqlQuery_1.default.join(fields, sql(templateObject_15 || (templateObject_15 = __makeTemplateObject([", "], [", "])))), SqlQuery_1.default.join(values, sql(templateObject_16 || (templateObject_16 = __makeTemplateObject([", "], [", "]))))))];
                    case 1:
                        results = _a.sent();
                        return [2 /*return*/, this.createModelFromAttributes(results[0])];
                }
            });
        });
    };
    CrudRepository.prototype.update = function (model, attributes) {
        return __awaiter(this, void 0, void 0, function () {
            var fieldQueries, results, newModel;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fieldQueries = Object.entries(attributes).map(function (_a) {
                            var _b = __read(_a, 2), key = _b[0], value = _b[1];
                            return (sql(templateObject_18 || (templateObject_18 = __makeTemplateObject(["", " = ", ""], ["", " = ", ""])), new QueryIdentifier_1.default(key), value));
                        });
                        return [4 /*yield*/, this.database.query(sql(templateObject_20 || (templateObject_20 = __makeTemplateObject(["\n\t\t\tUPDATE ", "\n\t\t\tSET ", "\n\t\t\tWHERE ", " = ", "\n\t\t\tRETURNING *;\n\t\t"], ["\n\t\t\tUPDATE ", "\n\t\t\tSET ", "\n\t\t\tWHERE ", " = ", "\n\t\t\tRETURNING *;\n\t\t"])), new QueryIdentifier_1.default(this.table), SqlQuery_1.default.join(fieldQueries, sql(templateObject_19 || (templateObject_19 = __makeTemplateObject([", "], [", "])))), new QueryIdentifier_1.default(this.primaryKey), model[this.primaryKey]))];
                    case 1:
                        results = _a.sent();
                        if (results.length === 0) {
                            throw new NotFoundError_1.default("Object not found in table " + this.table + " for " + this.primaryKey + " = " + model[this.primaryKey]);
                        }
                        if (results.length > 1) {
                            throw new TooManyResultsError_1.default("Multiple objects found in table " + this.table + " for " + this.primaryKey + " = " + model[this.primaryKey]);
                        }
                        return [4 /*yield*/, this.createModelFromAttributes(model)];
                    case 2:
                        newModel = _a.sent();
                        Object.assign(newModel, results[0]);
                        return [2 /*return*/, newModel];
                }
            });
        });
    };
    CrudRepository.prototype.delete = function (model) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.database.query(sql(templateObject_21 || (templateObject_21 = __makeTemplateObject(["\n\t\t\tDELETE FROM ", "\n\t\t\tWHERE ", " = ", ";\n\t\t"], ["\n\t\t\tDELETE FROM ", "\n\t\t\tWHERE ", " = ", ";\n\t\t"])), new QueryIdentifier_1.default(this.table), new QueryIdentifier_1.default(this.primaryKey), model[this.primaryKey]))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CrudRepository.prototype.createModelFromAttributes = function (attributes) {
        return __awaiter(this, void 0, void 0, function () {
            var model;
            return __generator(this, function (_a) {
                model = Object.create(this.model.prototype);
                Object.assign(model, attributes);
                return [2 /*return*/, model];
            });
        });
    };
    CrudRepository.prototype.loadRelationship = function (model, relationshipName) {
        return __awaiter(this, void 0, void 0, function () {
            var newModel, relationshipData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.relationships.hasOwnProperty(relationshipName)) {
                            throw new RelationshipNotFoundError_1.default("The relationship named " + relationshipName + " does not exist (table " + this.table + ").");
                        }
                        return [4 /*yield*/, this.createModelFromAttributes(model)];
                    case 1:
                        newModel = _a.sent();
                        return [4 /*yield*/, this.relationships[relationshipName](model)];
                    case 2:
                        relationshipData = _a.sent();
                        Object.defineProperty(newModel, relationshipName, { value: relationshipData });
                        return [2 /*return*/, newModel];
                }
            });
        });
    };
    return CrudRepository;
}());
exports.default = CrudRepository;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18, templateObject_19, templateObject_20, templateObject_21;
